build_llvm revision 602d0050832d5969e15301b6fca2c5a488e32eac
1#!/bin/sh
2# LLVM LOCAL file B&I
3
4set -x
5
6# Build LLVM the "Apple way".
7# Parameters:
8
9# The first parameter is a space-separated list of the architectures the
10# compilers will run on. For instance, "ppc i386". If the current machine
11# isn't in the list, it will (effectively) be added.
12# FIXME: HOSTS is not used in this script. Use it or Remove it.
13HOSTS="$1"
14
15# The second parameter is a space-separated list of the architectures the
16# compilers will generate code for. If the current machine isn't in the list, a
17# compiler for it will get built anyway, but won't be installed.
18TARGETS="$2"
19
20# The third parameter is the path to the compiler sources. There should be a
21# shell script named 'configure' in this directory. This script makes a copy...
22ORIG_SRC_DIR="$3"
23
24# The fourth parameter is the location where the LLVM will be installed. You can
25# move it once it's built, so this mostly controls the layout of $DEST_DIR.
26DEST_ROOT="$4"
27
28# The fifth parameter is the place where the compiler will be copied once it's
29# built.
30DEST_DIR="$5"
31
32# The sixth parameter is a directory in which to place information (like
33# unstripped executables and generated source files) helpful in debugging the
34# resulting compiler.
35SYM_DIR="$6"
36
37# The seventh parameter is a yes/no that indicates whether assertions should be
38# enabled in the LLVM libs/tools.
39LLVM_ASSERTIONS="$7"
40
41# The eighth parameter is a yes/no that indicates whether this is an optimized
42# build.
43LLVM_OPTIMIZED="$8"
44
45# The nineth parameter is the version number of the submission, e.g. 1007.
46LLVM_SUBMIT_VERSION="$9"
47
48# The tenth parameter is the subversion number of the submission, e.g. 03.
49LLVM_SUBMIT_SUBVERSION="${10}"
50
51# The current working directory is where the build will happen. It may already
52# contain a partial result of an interrupted build, in which case this script
53# will continue where it left off.
54DIR=`pwd`
55
56DARWIN_VERS=`uname -r | sed 's/\..*//'`
57echo DARWIN_VERS = $DARWIN_VERS
58
59if [ "x$RC_ProjectName" = "xllvmCore_Embedded" ]; then
60    DEST_DIR="$DEST_DIR/Developer/Platforms/iPhoneOS.platform"
61    mkdir -p "$DEST_DIR"
62fi
63
64DEVELOPER_DIR="${DEVELOPER_DIR-Developer}"
65if [ "x$RC_ProjectName" = "xllvmCore_EmbeddedHosted" ]; then
66    DT_HOME="$DEST_DIR/usr"
67    HOST_SDKROOT=$SDKROOT
68else
69    DT_HOME="$DEST_DIR/$DEVELOPER_DIR/usr"
70fi
71
72DEST_ROOT="/$DEVELOPER_DIR$DEST_ROOT"
73
74################################################################################
75# Run the build.
76
77# Create the source tree we'll actually use to build, deleting
78# tcl since it doesn't actually build properly in a cross environment
79# and we don't really need it.
80SRC_DIR=$DIR/src
81rm -rf $SRC_DIR || exit 1
82mkdir $SRC_DIR || exit 1
83ln -s $ORIG_SRC_DIR/* $SRC_DIR/ || exit 1
84# We can't use the top-level Makefile as-is.  Remove the soft link:
85rm $SRC_DIR/Makefile || exit 1
86# Now create our own by editing the top-level Makefile, deleting every line marked "Apple-style":
87sed -e '/[Aa]pple-style/d' -e '/include.*GNUmakefile/d' $ORIG_SRC_DIR/Makefile > $SRC_DIR/Makefile || exit 1
88
89# Build the LLVM tree universal.
90mkdir -p $DIR/obj-llvm || exit 1
91cd $DIR/obj-llvm || exit 1
92
93
94if [ "x$RC_ProjectName" = "xllvmCore_EmbeddedHosted" ]; then
95  # The cross-tools' build process expects to find an existing cross toolchain
96  # under names like 'arm-apple-darwin$DARWIN_VERS-as'; so make them.
97  rm -rf $DIR/bin || exit 1
98  mkdir $DIR/bin || exit 1
99  for prog in ar nm ranlib strip lipo ld as ; do
100    P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
101    T=`xcrun -sdk $SDKROOT -find ${prog}`
102    echo '#!/bin/sh' > $P || exit 1
103    echo 'exec '$T' "$@"' >> $P || exit 1
104    chmod a+x $P || exit 1
105  done
106  # Try to use the platform llvm-gcc. Fall back to gcc if it's not available.
107  for prog in gcc g++ ; do
108    P=$DIR/bin/arm-apple-darwin$DARWIN_VERS-${prog}
109    T=`xcrun -find llvm-${prog}`
110    if [ "x$T" = "x" ] ; then
111      T=`xcrun -sdk $SDKROOT -find ${prog}`
112    fi
113    echo '#!/bin/sh' > $P || exit 1
114    echo 'exec '$T' -arch armv6 -isysroot '${SDKROOT}' "$@"' >> $P || exit 1
115    chmod a+x $P || exit 1
116  done
117
118  PATH=$DIR/bin:$PATH
119# otherwise, try to use llvm-gcc if it's available
120elif [ $DARWIN_VERS -gt 9 ]; then
121  # If the user has set CC or CXX, respect their wishes.  If not,
122  # compile with LLVM-GCC/LLVM-G++ if available; if LLVM is not
123  # available, fall back to usual GCC/G++ default.
124  savedPATH=$PATH ; PATH="/Developer/usr/bin:$PATH"
125  XTMPCC=$(which llvm-gcc)
126  if [ x$CC  = x -a x$XTMPCC != x ] ; then export CC=$XTMPCC  ; fi
127  XTMPCC=$(which llvm-g++)
128  if [ x$CXX = x -a x$XTMPCC != x ] ; then export CXX=$XTMPCC ; fi
129  PATH=$savedPATH
130  unset XTMPCC savedPATH
131fi
132
133
134if [ "x$RC_ProjectName" = "xllvmCore_EmbeddedHosted" ]; then
135  if [ \! -f Makefile.config ]; then
136      $SRC_DIR/configure --prefix=$DT_HOME \
137          --enable-targets=arm \
138          --host=arm-apple-darwin10 \
139          --target=arm-apple-darwin10 \
140          --build=i686-apple-darwin10 \
141          --enable-assertions=$LLVM_ASSERTIONS \
142          --enable-optimized=$LLVM_OPTIMIZED \
143          --disable-bindings \
144          || exit 1
145  fi
146else
147  if [ \! -f Makefile.config ]; then
148      $SRC_DIR/configure --prefix=$DT_HOME/local \
149          --enable-targets=arm,x86,powerpc,cbe \
150          --enable-assertions=$LLVM_ASSERTIONS \
151          --enable-optimized=$LLVM_OPTIMIZED \
152          --disable-bindings \
153          || exit 1
154  fi
155fi
156
157SUBVERSION=`echo $RC_ProjectSourceVersion | sed -e 's/[^.]*\.\([0-9]*\).*/\1/'`
158
159if [ "x$SUBVERSION" != "x$RC_ProjectSourceVersion" ]; then
160    LLVM_SUBMIT_SUBVERSION=`printf "%02d" $SUBVERSION`
161    RC_ProjectSourceVersion=`echo $RC_ProjectSourceVersion | sed -e 's/\..*//'`
162    LLVM_SUBMIT_VERSION=$RC_ProjectSourceVersion
163fi
164
165if [ "x$LLVM_SUBMIT_SUBVERSION" = "x00" -o "x$LLVM_SUBMIT_SUBVERSION" = "x0" ]; then
166    LLVM_VERSION="$LLVM_SUBMIT_VERSION"
167else
168    LLVM_VERSION="$LLVM_SUBMIT_VERSION-$LLVM_SUBMIT_SUBVERSION"
169fi
170
171GCC_VER=`cc --version 2>/dev/null | sed 1q`
172
173if echo "$GCC_VER" | grep GCC > /dev/null; then
174    GCC_VER=`echo $GCC_VER | sed -e 's/.*(GCC) \([0-9.][0-9.]*\).*/\1/'`
175    MAJ_VER=`echo $GCC_VER | sed 's/\..*//'`
176    MIN_VER=`echo $GCC_VER | sed 's/[^.]*\.\([0-9]*\).*/\1/'`
177fi
178
179JOBS_FLAG=""
180
181# Note: If compiling with GCC 4.0, don't pass the -jN flag. Building universal
182# already has parallelism and we don't want to make the builders hit swap by
183# firing off too many gccs at the same time.
184if [ "x$MAJ_VER" != "x4" -o "x$MIN_VER" != "x0" ]; then
185    # Figure out how many make processes to run.
186    SYSCTL=`sysctl -n hw.activecpu`
187
188    # hw.activecpu only available in 10.2.6 and later
189    if [ -z "$SYSCTL" ]; then
190        SYSCTL=`sysctl -n hw.ncpu`
191    fi
192
193    # sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot.
194    # Builders can default to 2, since even if they are single processor,
195    # nothing else is running on the machine.
196    if [ -z "$SYSCTL" ]; then
197        SYSCTL=2
198    fi
199
200    JOBS_FLAG="-j $SYSCTL"
201fi
202
203make $JOBS_FLAG $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$TARGETS" \
204    UNIVERSAL_SDK_PATH=$HOST_SDKROOT \
205    NO_RUNTIME_LIBS=1 \
206    DISABLE_EDIS=1 \
207    LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
208    LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
209    CXXFLAGS="-DLLVM_VERSION_INFO='\" Apple Build #$LLVM_VERSION\"'" \
210    VERBOSE=1
211
212if [ $? != 0 ] ; then
213    echo "error: LLVM 'make' failed!"
214    exit 1
215fi 
216
217################################################################################
218# Construct the actual destination root, by copying stuff from $DIR/dst-* to
219# $DEST_DIR, with occasional 'lipo' commands.
220
221cd $DEST_DIR || exit 1
222
223# Clean out DEST_DIR in case -noclean was passed to buildit.
224rm -rf * || exit 1
225
226cd $DIR/obj-llvm || exit 1
227
228# Install the tree into the destination directory.
229make $LOCAL_MAKEFLAGS $OPTIMIZE_OPTS UNIVERSAL=1 UNIVERSAL_ARCH="$TARGETS" \
230    NO_RUNTIME_LIBS=1 \
231    DISABLE_EDIS=1 \
232    LLVM_SUBMIT_VERSION=$LLVM_SUBMIT_VERSION \
233    LLVM_SUBMIT_SUBVERSION=$LLVM_SUBMIT_SUBVERSION \
234    OPTIMIZE_OPTION='-O3' VERBOSE=1 install
235
236if ! test $? == 0 ; then
237    echo "error: LLVM 'make install' failed!"
238    exit 1
239fi 
240
241# Install Version.h
242LLVM_MINOR_VERSION=`echo $LLVM_SUBMIT_SUBVERSION | sed -e 's,0*\([1-9][0-9]*\),\1,'`
243if [ "x$LLVM_MINOR_VERSION" = "x" ]; then
244    LLVM_MINOR_VERSION=0
245fi
246RC_ProjectSourceSubversion=`printf "%d" $LLVM_MINOR_VERSION`
247echo "#define LLVM_VERSION ${RC_ProjectSourceVersion}" > $DEST_DIR$DEST_ROOT/include/llvm/Version.h
248echo "#define LLVM_MINOR_VERSION ${RC_ProjectSourceSubversion}" >> $DEST_DIR$DEST_ROOT/include/llvm/Version.h
249
250if [ "x$LLVM_DEBUG" != "x1" ]; then
251    # Strip local symbols from llvm libraries.
252    strip -S $DEST_DIR$DEST_ROOT/lib/*.[oa]
253    for f in `ls $DEST_DIR$DEST_ROOT/lib/*.so`; do
254        strip -Sx $f
255    done
256fi
257
258# Copy over the tblgen utility.
259cp `find $DIR -name tblgen` $DT_HOME/local/bin
260
261# Remove .dir files 
262cd $DEST_DIR$DEST_ROOT
263rm -f bin/.dir etc/llvm/.dir lib/.dir
264
265# Remove PPC64 fat slices.
266cd $DEST_DIR$DEST_ROOT/bin
267if [ $MACOSX_DEPLOYMENT_TARGET = "10.4" ]; then
268    find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
269        -exec lipo -extract ppc -extract i386 {} -output {} \;
270elif [ $MACOSX_DEPLOYMENT_TARGET = "10.5" ]; then
271    find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
272        -exec lipo -extract ppc7400 -extract i386 {} -output {} \;
273else
274    find . -perm 755 -type f \! \( -name '*gccas' -o -name '*gccld' -o -name llvm-config \) \
275        -exec lipo -extract ppc7400 -extract i386 -extract x86_64 {} -output {} \;
276fi
277
278cd $DEST_DIR$DEST_ROOT
279mkdir -p $DT_HOME/lib
280mv lib/libLTO.dylib $DT_HOME/lib/libLTO.dylib
281strip -S $DT_HOME/lib/libLTO.dylib
282rm -f lib/libLTO.a lib/libLTO.la
283
284# The Hello dylib is an example of how to build a pass. No need to install it.
285rm lib/libLLVMHello.dylib
286
287# Compress manpages
288MDIR=$DEST_DIR$DEST_ROOT/share/man/man1
289gzip -f $MDIR/*
290
291################################################################################
292# Create SYM_DIR with information required for debugging.
293
294# Figure out how many make processes to run.
295SYSCTL=`sysctl -n hw.activecpu`
296
297# hw.activecpu only available in 10.2.6 and later
298if [ -z "$SYSCTL" ]; then
299  SYSCTL=`sysctl -n hw.ncpu`
300fi
301
302# sysctl -n hw.* does not work when invoked via B&I chroot /BuildRoot. Builders
303# can default to 2, since even if they are single processor, nothing else is
304# running on the machine.
305if [ -z "$SYSCTL" ]; then
306  SYSCTL=2
307fi
308
309cd $SYM_DIR || exit 1
310
311# Clean out SYM_DIR in case -noclean was passed to buildit.
312rm -rf * || exit 1
313
314# Generate .dSYM files
315find $DEST_DIR -perm -0111 -type f \
316    ! \( -name '*.la' -o -name gccas -o -name gccld -o -name llvm-config -o -name '*.a' \) \
317    -print | xargs -n 1 -P ${SYSCTL} dsymutil
318
319# Save .dSYM files and .a archives
320cd $DEST_DIR || exit 1
321find . \( -path \*.dSYM/\* -or -name \*.a \) -print \
322    | cpio -pdml $SYM_DIR || exit 1
323
324# Save source files.
325mkdir $SYM_DIR/src || exit 1
326cd $DIR || exit 1
327find obj-* -name \*.\[chy\] -o -name \*.cpp -print \
328    | cpio -pdml $SYM_DIR/src || exit 1
329
330################################################################################
331# Remove debugging information from DEST_DIR.
332
333find $DEST_DIR -name \*.a -print | xargs ranlib || exit 1
334find $DEST_DIR -name \*.dSYM -print | xargs rm -r || exit 1
335chgrp -h -R wheel $DEST_DIR
336chgrp -R wheel $DEST_DIR
337
338################################################################################
339# Remove tar ball from docs directory
340
341find $DEST_DIR -name html.tar.gz -exec rm {} \;
342
343################################################################################
344# symlinks so that B&I can find things
345
346cd $DEST_DIR
347mkdir -p ./usr/lib/
348cd usr/lib
349ln -s ../../$DEVELOPER_DIR/usr/lib/libLTO.dylib ./libLTO.dylib
350
351################################################################################
352# w00t! Done!
353
354exit 0
355